package com.fp.persistence.plog.log;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TLOGLOAD*/
@Embeddable
public class TlogLoadKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="JOURNALID", nullable=false,updatable=false)

/**
* Numero de mensaje asociado a la transaccion.
*/
private String journalid;

@Column(name="LOADSEQUENCE", nullable=false,updatable=false)

/**
* Secuencia de la carga cuando se porcesa lotes
*/
private Long loadsequence;

/**Contructor por defecto*/
public TlogLoadKey(){}
/**Contructor de TlogLoadKey
@param pJournalid Numero de mensaje asociado a la transaccion.
@param pLoadsequence Secuencia de la carga cuando se porcesa lotes
*/
public TlogLoadKey(String pJournalid,Long pLoadsequence){
 journalid=pJournalid;
 loadsequence=pLoadsequence;
}
/**Obtiene el valor de journalid
@return valor de journalid*/
public String getJournalid(){
  return journalid;
}
/**Fija el valor de journalid
@param pJournalid nuevo Valor de journalid*/
public void setJournalid(String pJournalid){
  journalid=pJournalid;
}

/**Obtiene el valor de loadsequence
@return valor de loadsequence*/
public Long getLoadsequence(){
  return loadsequence;
}
/**Fija el valor de loadsequence
@param pLoadsequence nuevo Valor de loadsequence*/
public void setLoadsequence(Long pLoadsequence){
  loadsequence=pLoadsequence;
}

/**Implementacion de la comparacion de TlogLoadKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TlogLoadKey))return false;
  TlogLoadKey that = (TlogLoadKey) o;
  if (this.getJournalid() == null || that.getJournalid() == null){
      return false;
  }
  if (! this.getJournalid().equals(that.getJournalid())){
    return false;
  }
  if (this.getLoadsequence() == null || that.getLoadsequence() == null){
      return false;
  }
  if (! this.getLoadsequence().equals(that.getLoadsequence())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia TlogLoadKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getJournalid() == null ? 0 : this.getJournalid().hashCode());
    result = result * 37 + (this.getLoadsequence() == null ? 0 : this.getLoadsequence().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
